<?php

//////////
///
///   assign.inc.php
///
//////////

require_once('lib/commons.inc.php');



/*************\
*   METHODS   *
\*************/

$dm['assign.add'] = array('func'   => 'assign_add',
                          'perm'   => AL_ADMN,
                          'escape' => true);

$dm['assign.del'] = array('func'   => 'assign_del',
                          'perm'   => AL_ADMN,
                          'escape' => true);

$dm['assign.get'] = array('func'   => 'assign_get',
                          'perm'   => AL_ADMN,
                          'escape' => true);



/***************\
*   FUNCTIONS   *
\***************/

function assign_add($activity_id, $group_id)
{
   $em[1062] = array('assign', 'exists');
   $em[1452] = array('assign', 'nosuchactivitygroup');

   trace('assign.add', "activity_id=$activity_id, group_id=$group_id", 0, $group_id, $activity_id, 0, 0);

   $sql  = "INSERT INTO `activity_group` (`activity_id`, ";
   $sql .=                               "`group_id`) ";
   $sql .= "VALUES ('$activity_id', ";
   $sql .=         "'$group_id')";

   $ret = db_query($sql, $em);

   setaccess($_SESSION['authuserid']);

   return $ret;
}

function assign_del($activity_id, $group_id)
{
   trace('assign.del', "activity_id=$activity_id, group_id=$group_id", 0, $group_id, $activity_id, 0, 0);

   $sql  = "DELETE FROM `activity_group` ";
   $sql .= "WHERE `activity_id` = '$activity_id' AND ";
   $sql .=       "`group_id` = '$group_id'";

   $ret = db_query($sql);

   setaccess($_SESSION['authuserid']);

   return $ret;
}

function assign_get($activity_id, $group_id)
{
   $sql  = "SELECT `activity_id`, ";
   $sql .=        "`group_id` ";
   $sql .= "FROM `activity_group` ";
   $sql .= "WHERE 1";
   $sql .= ($activity_id ? " AND `activity_id` = '$activity_id'" : '');
   $sql .= ($group_id ? " AND `group_id` = '$group_id'" : '');

   $ret = db_query($sql);

   if(!is_success($ret)) {
      return $ret;
   } else if($ret['payload'] === false) {
      return success(array());
   }

   return $ret;
}

?>
