<?php

//////////
///
///   monitor.inc.php
///
//////////

require_once('lib/commons.inc.php');



/*************\
*   METHODS   *
\*************/

$dm['monitor.set']  = array('func'   => 'monitor_set',
                           'perm'   => AL_SERV,
                           'escape' => true);

$dm['monitor.del']  = array('func'   => 'monitor_del',
                           'perm'   => AL_ADMN,
                           'escape' => true);

$dm['monitor.stat'] = array('func'   => 'monitor_stat',
                            'perm'   => AL_ADMN | AL_SERV | AL_TECH | AL_VIEW,
                            'escape' => true);



/***************\
*   FUNCTIONS   *
\***************/

function monitor_set($monitor, $status, $desc, $disk, $cputotal, $cpuprocess)
{
   $sql  = "SELECT `monitor_id` ";
   $sql .= "FROM `monitor` ";
   $sql .= "WHERE `monitor` = '$monitor' AND ";
   $sql .=       "`remoteip` = '".$_SERVER['REMOTE_ADDR']."'";

   $ret = db_query($sql);

   if(!is_success($ret)) {
      return $ret;
   } else if($ret['payload'] === false) {
      $sql  = "INSERT INTO `monitor` (`monitor`, ";
      $sql .=                        "`remoteip`, ";
      $sql .=                        "`timestamp`, ";
      $sql .=                        "`status`, ";
      $sql .=                        "`desc`, ";
      $sql .=                        "`disk`, ";
      $sql .=                        "`cputotal`, ";
      $sql .=                        "`cpuprocess`) ";
      $sql .= "VALUES ('$monitor', ";
      $sql .=         "'".$_SERVER['REMOTE_ADDR']."', ";
      $sql .=         "UTC_TIMESTAMP(), ";
      $sql .=         "'$status', ";
      $sql .=         "'$desc', ";
      $sql .=         "'$disk', ";
      $sql .=         "'$cputotal', ";
      $sql .=         "'$cpuprocess')";
   } else {
      $sql  = "UPDATE `monitor` ";
      $sql .= "SET `monitor` = '$monitor', ";
      $sql .=     "`remoteip` = '".$_SERVER['REMOTE_ADDR']."', ";
      $sql .=     "`timestamp` = UTC_TIMESTAMP(), ";
      $sql .=     "`status` = '$status', ";
      $sql .=     "`desc` = '$desc', ";
      $sql .=     "`disk` = '$disk', ";
      $sql .=     "`cputotal` = '$cputotal', ";
      $sql .=     "`cpuprocess` =  '$cpuprocess' ";
      $sql .= "WHERE `monitor_id` = '".$ret['payload'][0]->monitor_id."'";
   }

   return db_query($sql);
}

function monitor_del($monitor_id)
{
   $sql  = "DELETE FROM `monitor` ";
   $sql .= "WHERE `monitor_id` = '$monitor_id'";

   return db_query($sql);
}

function monitor_stat()
{
   $sql  = "SHOW PROCESSLIST";

   $ret = db_query($sql);

   if(!is_success($ret)) {
      return $ret;
   }

   $selfstat->monitor_id = -1;
   $selfstat->monitor = 'DB';
   $selfstat->remoteip = '';
   $selfstat->timestamp = date('c', time());
   $selfstat->status = 'OK';
   $selfstat->desc = 'Running queries: '.count($ret['payload']);
   $selfstat->disk = (integer)(disk_free_space('C:\RCSDB') * 100 / disk_total_space('C:\RCSDB'));
   $selfstat->cputotal = -1;
   $selfstat->cpuprocess = -1;
   xmlrpc_set_type($selfstat->timestamp, 'datetime');

   $sql  = "SELECT `monitor_id`, ";
   $sql .=        "`monitor`, ";
   $sql .=        "`remoteip`, ";
   $sql .=        "`timestamp`, ";
   $sql .=        "`status`, ";
   $sql .=        "`desc`, ";
   $sql .=        "`disk`, ";
   $sql .=        "`cputotal`, ";
   $sql .=        "`cpuprocess` ";
   $sql .= "FROM `monitor`";

   $ret = db_query($sql);

   if(!is_success($ret)) {
      return $ret;
   }

   $ret['payload'][] = $selfstat;

   return $ret;
}

?>
