<?php

//////////
///
///   security.inc.php
///
//////////

require_once('lib/db.inc.php');
require_once('lib/err.inc.php');



/***************\
*   FUNCTIONS   *
\***************/

function takeover($user_id)
{
   $sql  = "SELECT `session` ";
   $sql .= "FROM `session` ";
   $sql .= "WHERE `user_id` = '$user_id'";

   $ret = db_query($sql);

   $session = session_id();

   if(!is_success($ret)) {
      return $ret;
   } else if($ret['payload'] !== false) {
      $session = session_id();
      session_id($ret['payload'][0]->session);
      session_destroy();
      session_id($session);
      session_start();
   }

   $sql  = "REPLACE INTO `session` ";
   $sql .= "SET `timestamp` = UTC_TIMESTAMP(), ";
   $sql .=     "`session` = '$session', ";
   $sql .=     "`remoteip` = '".$_SERVER['REMOTE_ADDR']."', ";
   $sql .=     "`user_id` = '$user_id' ";

   return db_query($sql);
}

function setaccess($user_id)
{
   unset($_SESSION['authactivityid']);
   unset($_SESSION['authtargetid']);
   unset($_SESSION['authbackdoorid']);

   $sql  = "SELECT `activity_id` ";
   $sql .= "FROM `activity_group` ";
   $sql .= "JOIN `group_user` ";
   $sql .= "USING (`group_id`) ";
   $sql .= "WHERE `user_id` = '$user_id'";

   $ret = db_query($sql);

   if(!is_success($ret)) {
      return $ret;
   } else if($ret['payload'] === false) {
      $_SESSION['authactivityid'] = array(0);
   } else {
      foreach($ret['payload'] as $r) {
         $_SESSION['authactivityid'][] = $r->activity_id;
      }
   }

   $sql  = "SELECT `target_id` ";
   $sql .= "FROM `target` ";
   $sql .= "WHERE `activity_id` IN ('".implode("', '", $_SESSION['authactivityid'])."')";

   $ret = db_query($sql);

   if(!is_success($ret)) {
      return $ret;
   } else if($ret['payload'] === false) {
      $_SESSION['authtargetid'] = array(0);
   } else {
      foreach($ret['payload'] as $r) {
         $_SESSION['authtargetid'][] = $r->target_id;
      }
   }

   $sql  = "SELECT `backdoor_id` ";
   $sql .= "FROM `backdoor` ";
   $sql .= "WHERE `target_id` IN ('".implode("', '", $_SESSION['authtargetid'])."')";

   $ret = db_query($sql);

   if(!is_success($ret)) {
      return $ret;
   } else if($ret['payload'] === false) {
      $_SESSION['authbackdoorid'] = array(0);
   } else {
      foreach($ret['payload'] as $r) {
         $_SESSION['authbackdoorid'][] = $r->backdoor_id;
      }
   }

   return success(true);
}

function trace($action, $desc, $user_id, $group_id, $activity_id, $target_id, $backdoor_id)
{
   $sql  = "INSERT INTO `trace` (`timestamp`, ";
   $sql .=                      "`user`, ";
   $sql .=                      "`action`, ";
   $sql .=                      "`desc`, ";
   $sql .=                      "`user_id`, ";
   $sql .=                      "`group_id`, ";
   $sql .=                      "`activity_id`, ";
   $sql .=                      "`target_id`, ";
   $sql .=                      "`backdoor_id`) ";
   $sql .= "VALUES (UTC_TIMESTAMP(), ";
   $sql .=         "'{$_SESSION['authuser']}', ";
   $sql .=         "'$action', ";
   $sql .=         "'$desc', ";
   $sql .=         "'$user_id', ";
   $sql .=         "'$group_id', ";
   $sql .=         "'$activity_id', ";
   $sql .=         "'$target_id', ";
   $sql .=         "'$backdoor_id')";

   return db_query($sql);
}

?>
